import prism, types
from twisted.web.resource import Resource

class Crystal(Resource):

    isLeaf = False
    
    def __init__(self, prismMod):
        Resource.__init__(self) 
        self.putChild('', self)
        self.prismMod = prismMod
        self.prisms = {}
        self.facets = {}
   
        
        for attrId in dir(prismMod):
            attr = getattr(prismMod, attrId)
            
            if isinstance(attr, types.ClassType):

                if issubclass(attr, prism.Prism):
                    self.prisms[attr.__name__] = attr()
                    
                elif issubclass(attr, prism.Facet):
                    self.facets[attr.__name__] = attr()
                    
        for key, value in self.prisms.items():
            print "adding some facets to the "+key+" prism:"
            for f in value.facets:
                print "\t"+f.__name__
                value.addFacet(f.__name__, self.facets[f.__name__])

        for key, value in self.prisms.items():
            self.putChild(value.getUrl(), value)

    def render(self, request):
        output = ''
        for key, value in self.prisms.items():
            output = output + "<a href='"+value.getUrl()+"'>"
            output = output + value.name+"</a><br>"
        return output


