from random import randrange
from twisted.web.resource import Resource
class Prism(Resource):
    isLeaf = True


    def __init__(self, *args, **kwargs):
        self.ofacets = {}

    def addFacet(self, name, facet):
        self.ofacets[name] = facet

    def getUrl(self):
        if hasattr(self, 'url'):
            return self.url
        else: 
            return 'no url'

    def render(self, request):
        output = 'A few facets:'
        for key, facet in self.ofacets.items():
            output = output + """
            <div style='position:absolute;
                        z-index:1;
                        height:%s;
                        width:%s;
                        border:1px ridge black;
                        top:%s;
                        left:%s;'>
            """ % (str(facet.height), str(facet.width), 
                    str(facet.top),  str(facet.left) )
            output = output + facet.render()
            output = output + "</div>";
        return output

class Facet:

    def __init__(self):
        self.top = 10
        self.left = 10
        self.height = 100
        self.width = 100

    def render(self):
        return "<b>I should be overloaded!</b>";

